#!/bin/bash

ROBOTSERVER_INDEX=$1

SCRIPTDIR=$(dirname $(realpath -s $0))

cd ${SCRIPTDIR}/../../../

if file -L ./vendetta | grep -q "ELF 64-bit"; then
    LIBNAME=libglspamserver64.so
else
    LIBNAME=libglspamserver.so
fi

if [ ! -x ${SCRIPTDIR}/${LIBNAME} ]; then
    echo "${LIBNAME} not found";
    exit
fi

if [ -z "${ROBOTSERVER_INDEX}" ]; then
    ROBOTSERVER_INDEX=$(grep "autostart_index=" config.ini | cut -d = -f 2)
fi

if [ -z "${ROBOTSERVER_INDEX}" ]; then
    echo "index parameter missing and none found in config.ini"
    exit
fi

if [[ ! "${ROBOTSERVER_INDEX}" =~ ^[0-9]+$ || "${ROBOTSERVER_INDEX}" -lt 0 || "${ROBOTSERVER_INDEX}" -gt 19 ]]; then
    echo "invalid server index: ${ROBOTSERVER_INDEX}"
    exit
fi

echo "starting server with index: ${ROBOTSERVER_INDEX}"

export ROBOTSERVER_INDEX
export LD_LIBRARY_PATH=${LD_LIBRARY_PATH}:./drivers:.

LD_PRELOAD=${SCRIPTDIR}/${LIBNAME} ./vendetta
