-- tspammer turret bot

-- Copyright (c) 2015 Stefan Scheffler

-- Permission is hereby granted, free of charge, to any person
-- obtaining a copy of this software and associated documentation
-- files (the "Software"), to deal in the Software without
-- restriction, including without limitation the rights to use,
-- copy, modify, merge, publish, distribute, sublicense, and/or sell
-- copies of the Software, and to permit persons to whom the
-- Software is furnished to do so, subject to the following
-- conditions:

-- The above copyright notice and this permission notice shall be
-- included in all copies or substantial portions of the Software.

-- THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
-- EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
-- OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
-- NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
-- HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
-- WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-- FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
-- OTHER DEALINGS IN THE SOFTWARE.


local json = dofile("json.lua")
local TCP = dofile("tcpsock.lua")

local autofire = {}

local finder = dofile("objectfinder.lua")

autofire.finderobj = finder.new()

autofire.index = 0
autofire.active = false

autofire.targettimer = Timer()

function autofire:block_mousewarp(block)
	local function conn_cb(conn, err)
		if err then
			console_print("Can't connect to server. error: "..tostring(err))
			return
		end
		local blockstr = block and "1" or "0"
		conn:Send("4 "..blockstr.."\n")
		conn.tcp:Disconnect()
	end
	
	local function stub_cb(conn, line)
		conn.tcp:Disconnect()
	end
	
	TCP.make_client("127.0.0.1", 57725 + self.index, conn_cb, stub_cb, stub_cb)
end


function autofire:retarget()
	if not self.nearest then
		radar.SetRadarSelection(self.targetnode, self.targetobject)
		return
	end

	local nearestdist = math.huge
	local nearestid

	local targets = {}

	local function player_cb(id)
		if id == 0 or GetPlayerName(id) == GetPlayerName() or IsGroupMember(id) then
			return
		end

		if self.nearest.nottarget and GetPlayerNodeID(id) == self.targetnode then
			return
		end

		local faction = GetPlayerFaction(id)
		-- XXX for some reason the faction 0 key gets turned into a string
		-- for new force lookup key as string. the table is also explicitly created with string indexes in tspammer_cb
		-- maybe it's the json lib?
		if self.nearest.factions and not self.nearest.factions[tostring(faction)] then
			return
		end
		
		
		local dist = GetPlayerDistance(id)
		if dist then
			if dist < nearestdist then
				nearestdist = dist
				nearestid = id
			end
			if dist < 1500 then
				table.insert(targets, { id, dist })
			end
		end
	end
	ForEachPlayer(player_cb)
	
	table.sort(targets, function(a, b) return (a[2] < b[2]) end)

	-- if nearestid is not set no targets are in range
	if nearestid then
		local id
		if nearestdist >= 1500 then
			id = nearestid
		else
			id = targets[math.ceil(math.random() * #targets)][1]
		end
		
		radar.SetRadarSelection(GetPlayerNodeID(id), GetPrimaryShipIDOfPlayer(id))
	end
end


function autofire:pick_turret()
	local startturret = self.nextturret
	local nextturret = startturret
	local tinfo
	
	repeat
		tinfo = GetStationTurretInfo(self.turrets[nextturret])
		if not tinfo then
			print("invalid turret")
			self:stop()
			return
		end
		
		if nextturret >= #self.turrets then
			nextturret = 1
		else
			nextturret = nextturret + 1
		end
	until not tinfo.controller or not tinfo.isdead or nextturret == startturret

	if tinfo.controller or tinfo.isdead then
		print("all selected turrets occupied or dead")
		self:stop()
		return
	end
	
	self.nextturret = nextturret
	self.tinfo = tinfo

	return true
end


function autofire:OnEvent(ev, data)
	if self.burst then
		return self:OnEvent_burst(ev, data)		
	else
		return self:OnEvent_default(ev, data)
	end
end


function autofire:OnEvent_burst(ev, data)
	if ev == "HUD_SHOW" and data == "turret" then
		local function timer_cb()
			if self.timeout > 0 and (os.time() - self.starttime) > self.timeout then
				print("burst done")
				self:stop()
				return
			end

			self:retarget()
			
			gkinterface.GKProcessCommand("+Shoot2")


			local waittime = (InvManager.InventoryItemTypeToName(self.tinfo.itemtype) == "PlayerCapshipSwarmLauncher") and 500 or 100
			
			local function timer_cb()
				gkinterface.GKProcessCommand("+Shoot2 0")
				gkinterface.GKProcessCommand("Activate")
			end

			self.targettimer:SetTimeout(waittime, timer_cb)
		end

		RegisterEvent(self, "ENTERED_STATION")

		self.targettimer:SetTimeout(100, timer_cb)
	elseif ev == "ENTERED_STATION" or (ev == "HUD_SHOW" and data == "ship") then
		UnregisterEvent(self, "ENTERED_STATION")
		UnregisterEvent(self, "HUD_SHOW")

		if not self:pick_turret() then
			print("failed to pick a turret")
			self:stop()
			return
		end
		
		RegisterEvent(self, "HUD_SHOW")
		PurchaseMerchandiseItem(self.tinfo.itemid)
	end
end

function autofire:OnEvent_default(ev, data)
	if ev == "HUD_SHOW" and data == "turret" then
		UnregisterEvent(self, "HUD_SHOW")
		RegisterEvent(self, "CHAT_MSG_PRINT")

		self.lastswitch = os.time()

		self.lasttarget = 0
		
		local function timer_cb()
			if self.timeout > 0 and (os.time() - self.lastswitch) > self.timeout then
				UnregisterEvent(self, "CHAT_MSG_PRINT")

				self.finderobj:Stop()
				
				gkinterface.GKProcessCommand("+Shoot2 0")

				RegisterEvent(self, "ENTERED_STATION")
				RegisterEvent(self, "HUD_SHOW")
				gkinterface.GKProcessCommand("Activate")
			else
				if (os.time() - self.lasttarget) > 2 then
					self:retarget()
					self.lasttarget = os.time()
				end
			
				gkinterface.GKProcessCommand("+Shoot2")
				self.targettimer:SetTimeout(500)
			end
		end
		self.targettimer:SetTimeout(100, timer_cb)

		self.finderobj:Init()
		self.finderobj:find(finder.OT_TARGETTRACK, function(err) print("finder: "..tostring(err)) end)
	elseif ev == "CHAT_MSG_PRINT" then
		if data.msg ~= "<CLICK!> Out of missiles!" then
			return
		end

		UnregisterEvent(self, "CHAT_MSG_PRINT")

		self.targettimer:Kill()		
		self.finderobj:Stop()

		gkinterface.GKProcessCommand("+Shoot2 0")

		RegisterEvent(self, "ENTERED_STATION")
		RegisterEvent(self, "HUD_SHOW")
		gkinterface.GKProcessCommand("Activate")
	elseif ev == "ENTERED_STATION" or (ev == "HUD_SHOW" and data == "ship") then
		UnregisterEvent(self, "ENTERED_STATION")
		UnregisterEvent(self, "HUD_SHOW")

		if not self:pick_turret() then
			print("failed to pick a turret")
			self:stop()
			return
		end
		
		RegisterEvent(self, "HUD_SHOW")
		PurchaseMerchandiseItem(self.tinfo.itemid)
	elseif ev == "PLAYER_ENTERED_SECTOR" or ev == "PLAYER_LEFT_SECTOR" then
		self:retarget()
	end
end

function autofire:start(targetnode, targetobject, turrets, nearest, index, burst, timeout)

	local samemode = (self.burst == burst)
	
	-- reset parameters
	self.targetnode = targetnode
	self.targetobject = targetobject
	self.turrets = turrets
	self.nextturret = 1
	self.nearest = nearest
	self.index = index
	self.finderobj:SetPort(57725 + index)
	self.burst = burst
	self.timeout = timeout or 15
	self.tinfo = {}
	
	self.starttime = os.time()
	self.lastswitch	= os.time()
	self.lasttarget = os.time()

	if self.active and HUD.hudtype == "turret" and samemode then
		print("active and in a turret. updating settings and target")
		self:retarget()
		return
	end

	-- make sure we are in a sane state
	self:stop()

	gkinterface.GKProcessCommand("radarhide 4 5 9 11")

	self:block_mousewarp(true)
	
	if not self.active then
		self:OnEvent("ENTERED_STATION")
	end

	RegisterEvent(self, "PLAYER_ENTERED_SECTOR")
	RegisterEvent(self, "PLAYER_LEFT_SECTOR")

	self.active = true
end

function autofire:stop()
	self.finderobj:Stop()

	self:block_mousewarp(false)

	gkinterface.GKProcessCommand("radarshow 4 5 9 11")

	self.active = false

	autofire.targettimer:Kill()

	UnregisterEvent(self, "PLAYER_ENTERED_SECTOR")
	UnregisterEvent(self, "PLAYER_LEFT_SECTOR")
	UnregisterEvent(self, "ENTERED_STATION")
	UnregisterEvent(self, "HUD_SHOW")
	UnregisterEvent(self, "TARGET_CHANGED")
	UnregisterEvent(self, "CHAT_MSG_PRINT")
	gkinterface.GKProcessCommand("+Shoot2 0")
	if HUD.hudtype == "turret" then
		gkinterface.GKProcessCommand("Activate")
	end
end


local function tspam_cb(_, args)
	if not args then
		print("missing [host:]index")
		return
	end

	local host, index
	local addr = tostring(table.remove(args, 1))
	if tonumber(addr) then
		index = tonumber(addr)
	else
		host, index = addr:match("(.*):(%d+)$")	
	end

	host = host or "127.0.0.1"
	
	index = tonumber(index)
	if not index then
		print("invalid index")
	end
	
	local nodeid, objectid = radar.GetRadarSelectionID()	

	local turrets = {}
	local nearest, burst, timeout, move, stop

	
	local factionids = {}
	for i,v in pairs(FactionName) do
		factionids[string.lower(v)] = tonumber(i)
	end

	
	if args then
		for _,arg in pairs(args) do
			if tonumber(arg) then
				table.insert(turrets, tonumber(arg))
			else
				local argp, argv = arg:match("([^=]+)=?([^=]*)")
				if argp == "timeout" then
					timeout = tonumber(argv)
				elseif argp == "burst" then
					burst = true
				elseif argp == "nearest" then
					local subopts = {}
					for opt in string.gmatch(argv, "[^,]+") do
						if factionids[opt] then
							subopts.factions = subopts.factions or {}
							subopts.factions[tostring(factionids[opt])] = true
						elseif opt == "nottarget" then
							subopts[opt] = true
						end
					end
					nearest = subopts
				elseif argp == "move" then
					move = true
				elseif argp == "stop" then
					stop = true
				end
			end
		end
	end

	
	local function conn_cb(conn, err)
		if err then
			print("Can't connect to turret. error: "..tostring(err))
			return
		end
		
		if #turrets > 0 then
			conn:Send(json.encode({type="autofire", nodeid=nodeid, objectid=objectid, turrets=turrets, nearest=nearest, burst=burst, timeout=timeout, move=move, stop=stop}).."\n")
		elseif move then
			conn:Send(json.encode({type="move"}).."\n")
		elseif stop then
			conn:Send(json.encode({type="stop"}).."\n")
		else			
			conn:Send(json.encode({type=""}).."\n")
		end
		conn.tcp:Disconnect()
	end
	
	local function stub_cb()
	end
	
	TCP.make_client(host, 57745 + index, conn_cb, stub_cb, stub_cb)
end
RegisterUserCommand("tspammer", tspam_cb)



local server
local clients = {}

local function tspamserver_start(index)
	if server then
		print("tspamserver already active")
		return
	end
		
	local function line_cb(conn, line)
		conn.tcp:Disconnect()
		
		local decoded, msgdata = pcall(json.decode, line)
		if decoded then
			if msgdata.type == "autofire" then
				autofire:start(msgdata.nodeid, msgdata.objectid, msgdata.turrets, msgdata.nearest, index, msgdata.burst, msgdata.timeout)
			elseif msgdata.type == "move" then
				Game.SetDesiredSpeed(1000)
			elseif msgdata.type == "stop" then
				Game.SetDesiredSpeed(0)
			else
				autofire:stop()
			end
		else
			autofire:stop()
		end
	end

	local function conn_cb(conn)
		console_print("client connect")
		clients[conn] = true
	end

	local function disc_cb(conn)
		console_print("client disconnect")
		clients[conn] = nil
	end

	
	server = TCP.make_server(57745 + index, conn_cb, line_cb, disc_cb)
end

local function tspamserver_stop()
	if autofire.active then
		autofire:stop()
	end
	
	if server then
		for client in pairs(clients) do
			client.tcp:Disconnect()
		end
		
		server:Disconnect()
		server = nil
	end
end


local function tserver_cb(_, args)
	if not args then
		print("stopping tspamserver")
		tspamserver_stop()
	else
		local index = tonumber(args[1])
		if not index or index < 0 or index > 19 then
			print("invalid index (0-19)")
		else
			print("starting tspamserver")
			tspamserver_start(index)
			return
		end
		print("usage: tserver <index>")
	end
end
RegisterUserCommand("tserver", tserver_cb)




local function unload_cb()
	tspamserver_stop()
end
RegisterEvent(unload_cb, "UNLOAD_INTERFACE")




local autostart = (gkini.ReadInt("*tspammer", "autostart", 0) == 1)
local autostart_index = gkini.ReadInt("*tspammer", "autostart_index", 0)

local function tspammer_autostart_index_cb(_, args)
	if args then
		local index = tonumber(args[1])
		if not index or index < 0 or index > 19 then
			print("invalid index (0 - 19)")
			print("usage tspammer_autostart_index <index>")
		else
			autostart_index = index
			gkini.WriteInt("*tspammer", "autostart_index", autostart_index)
		end
	end
	print("autostart index is: "..tostring(autostart_index))
end
RegisterUserCommand("tspammer_autostart_index", tspammer_autostart_index_cb)


local function tspammer_autostart_cb(_, args)
	if args then
		if args[1] == "on" then
			autostart = true
		else
			autostart = false
		end
		gkini.WriteInt("*tspammer", "autostart", autostart and 1 or 0)
		-- also update the index so that the startup script has something to update
		gkini.WriteInt("*tspammer", "autostart_index", autostart_index)
	end
	print("autostart enabled: "..tostring(autostart))
end
RegisterUserCommand("tspammer_autostart", tspammer_autostart_cb)


if autostart then
	tspamserver_start(autostart_index)
end
